package com.adaptionsoft.games.uglytrivia.infrastructure

import com.adaptionsoft.games.uglytrivia.actions.*
import com.adaptionsoft.games.uglytrivia.core.GameBoard
import com.adaptionsoft.games.uglytrivia.core.Rules
import com.adaptionsoft.games.uglytrivia.core.Turn
import java.util.*

class GameRunner(
    private val addPlayer: AddPlayer,
    private val correctAnswer: CorrectAnswer,
    private val wrongAnswer: WrongAnswer,
    private val roll: Roll,
    private val didSomeoneWon: DidSomeoneWon
) {
    fun play(random: BoundedRandom) {
        addPlayer("Chet")
        addPlayer("Pat")
        addPlayer("Sue")
        do {
            roll(random.nextInt(5) + 1)
            if (random.nextInt(9) == 7)
                wrongAnswer()
            else correctAnswer()
        } while (!didSomeoneWon())
    }
}

fun main(args: Array<String>) {
    val eventStream = StreamEventWriter(System.out)
    val turn = Turn()
    val gameboard = GameBoard(AutogeneratedQuestions(), InMemoryPlayerPositions())
    val rules = Rules(InMemoryPenaltyBox())

    val addPlayer = AddPlayer(gameboard, turn)
    val correctAnswer = CorrectAnswer(turn, rules)
    val wrongAnswer = WrongAnswer(turn, rules)
    val roll = Roll(gameboard, rules, turn)

    correctAnswer.correctAnswerEvent += eventStream::correctAnswer
    wrongAnswer.wrongAnswerEvent += eventStream::wrongAnswer
    gameboard.playerMovementEvent += eventStream::playerLocationChange
    gameboard.categoryChangeEvent += eventStream::categoryChange
    gameboard.playerAddedEvent += eventStream::playerAdded
    roll.turnStartEvent += eventStream::turnStart
    roll.askQuestion += eventStream::askQuestion
    rules.gettingOutPenaltyBox += eventStream::gettingOutPenaltyBox
    rules.sentToPenaltyBox += eventStream::sentToPenaltyBox
    rules.notGettingOutPenaltyBox += eventStream::notGettingOutPenaltyBox

    val gameRunner = GameRunner(
        addPlayer,
        correctAnswer,
        wrongAnswer,
        roll,
        DidSomeoneWon(turn)
    )
    gameRunner.play(object : BoundedRandom {
        val random = Random()
        override fun nextInt(bound: Int) = random.nextInt(bound)
    })

}
